﻿using SelfPropelledArtilleryUnit.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SelfPropelledArtilleryUnit.Drawnings;

public static class ExtentionDrawningPropelledArtillery
{
    /// <summary>
    /// Разделитель для записи информации по объекту в файл
    /// </summary>
    private static readonly string _separatorForObject = ":";
    /// <summary>
    /// Создание объекта из строки
    /// </summary>
    /// <param name="info">Строка с данными для создания объекта</param>
    /// <returns>Объект</returns>
    public static DrawningPropelledArtillery? CreateDrawningPropelledArtillery(this string info)
    {
        string[] strs = info.Split(_separatorForObject);
        EntityPropelledArtillery? propelledArtillery = EntitySelfPropelledArtilleryUnit.CreateEntitySelfPropelledArtilleryUnit(strs);
        if (propelledArtillery != null)
        {
            return new DrawningSelfPropelledArtilleryUnit((EntitySelfPropelledArtilleryUnit)propelledArtillery);
        }
        propelledArtillery = EntityPropelledArtillery.CreateEntityPropelledArtillery(strs);
        if (propelledArtillery != null)
        {
            return new DrawningPropelledArtillery(propelledArtillery);
        }
        return null;
    }
    /// <summary>
    /// Получение данных для сохранения в файл
    /// </summary>
    /// <param name="drawningCar">Сохраняемый объект</param>
    /// <returns>Строка с данными по объекту</returns>
    public static string GetDataForSave(this DrawningPropelledArtillery drawningPropelledArtillery)
    {
        string[]? array = drawningPropelledArtillery?.EntityPropelledArtillery?.GetStringRepresentation();
        if (array == null)
        {
            return string.Empty;
        }
        return string.Join(_separatorForObject, array);
    }
}
